import React, { PropTypes } from 'react'

const parseProps = ({
  block,
  inlineBlock,
  inline,
  table,
  tableRow,
  tableCell,
  flex,
  inlineFlex,
  style,
  ...props
}) => {
  const styles = {}

  if (block) styles.display = 'block'
  if (inlineBlock) styles.display = 'inline-block'
  if (inline) styles.display = 'inline'
  if (table) styles.display = 'table'
  if (tableRow) styles.display = 'table-row'
  if (tableCell) styles.display = 'table-cell'
  if (flex) styles.display = 'flex'
  if (inlineFlex) styles.display = 'inline-flex'

  return { style: { ...styles, ...style }, ...props }
}

const withDisplay = (Comp) => {
  const DisplayComp = (originalProps) => {
    return React.createElement(Comp, parseProps(originalProps))
  }

  DisplayComp.propTypes = {
    ...Comp.propTypes,
    block: PropTypes.bool,
    inlineBlock: PropTypes.bool,
    inline: PropTypes.bool,
    table: PropTypes.bool,
    tableRow: PropTypes.bool,
    tableCell: PropTypes.bool,
    flex: PropTypes.bool,
    inlineFlex: PropTypes.bool
  }

  DisplayComp.displayName = Comp.displayName

  return DisplayComp
}

export {
  withDisplay
}
