import React, { PropTypes } from 'react'
import styled, { css } from 'styled-components'

const styles = ({
  rotate
}) => css`
  ${rotate ? `transform: rotate(${rotate});` : ''}
`

const withRotate = (Comp) => {
  const RotateComp = styled(({
    rotate,
    ...props
  }) => React.createElement(Comp, props))`${styles}`

  RotateComp.propTypes = {
    ...Comp.propTypes,
    rotate: PropTypes.string
  }

  RotateComp.displayName = Comp.displayName

  return RotateComp
}

export {
  withRotate
}
